package org.xtext.example.mydsl.ui.handler;


import org.eclipse.core.commands.*;
import org.eclipse.core.internal.resources.Resource;
import org.eclipse.core.resources.*;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.NullProgressMonitor;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.ResourceSet;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.handlers.HandlerUtil;
import org.eclipse.xtext.builder.*;
import org.eclipse.xtext.generator.*;
import org.eclipse.xtext.resource.*;
import org.eclipse.xtext.ui.resource.*;

import com.google.inject.*;



public class GenerationHandler extends AbstractHandler implements IHandler {

	@Inject
	private IGenerator generator;
	
	@Inject
	private Provider<EclipseResourceFileSystemAccess> fileAccessProvider;
	
	@Inject
	IResourceDescriptions resourceDescriptions;
	
	@Inject
	IResourceSetProvider resourceSetProvider;
	
	

	@Override
	public Object execute(ExecutionEvent event) throws ExecutionException {
		ISelection selection = HandlerUtil.getCurrentSelection(event);
		if(selection instanceof IStructuredSelection) 
		{
			IStructuredSelection structuredSelection = (IStructuredSelection) selection;
			Object firstelement = structuredSelection.getFirstElement();
			if(firstelement instanceof IFile)
			{
				IFile file = (IFile)firstelement;
				IProject project = file.getProject();
				IFolder scrGenFolder = project.getFolder("src-gen"); // Todo search output Directory
				if(!scrGenFolder.exists())
				{
					try {
						scrGenFolder.create(true, true, new NullProgressMonitor());
						
					} catch(CoreException e) {
						return null;
					}
				}
				
				final EclipseResourceFileSystemAccess fsa = fileAccessProvider.get();
				fsa.setOutputPath(scrGenFolder.getFullPath().toString());
				
				URI uri = URI.createPlatformResourceURI(file.getFullPath().toString(), true);
				ResourceSet rs = resourceSetProvider.get(project);
				org.eclipse.emf.ecore.resource.Resource r = rs.getResource(uri, true);
				generator.doGenerate(r, fsa);
				
			}
		}
		
		return null;
	}

	@Override
	public boolean isEnabled() {
		return true;
	}

	

}
